//+------------------------------------------------------------------+
//|                                           SoundedTradeEvents.mq5 |
//|            Copyright 2013, https://login.mql5.com/ru/users/tol64 |
//|                                  Site, http://tol64.blogspot.com |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2013, http://tol64.blogspot.com"
#property link        "http://tol64.blogspot.com"
#property description "email: hello.tol64@gmail.com"
#property version     "1.0"
//---  
#define EXPERT_NAME MQL5InfoString(MQL5_PROGRAM_NAME)
//---    
#include <Trade/Trade.mqh>
//---   
#include "Include/Errors.mqh"
#include "Include/Enums.mqh"
#include "Include/Resources.mqh"
#include "Include/TradeSignals.mqh"
#include "Include/TradeFunctions.mqh"
#include "Include/ToString.mqh"
#include "Include/Auxiliary.mqh"
//---   
input  int        NumberOfBars =2;    //   
sinput double     Lot          =0.1;  // 
input  double     TakeProfit   =100;  //  
input  double     StopLoss     =50;   //  
input  double     TrailingStop =10;   //  
input  bool       Reverse      =true; //  
sinput bool       UseSound     =true; //  
//---  
MqlTick           last_tick;
//---  
CTrade            trade;
//---      NumberOfBars
int               AllowedNumberOfBars=0;
//---
double            close_price[]; // Close (  )
double            open_price[];  // Open (  )
double            high_price[];  // High (  )
double            low_price[];   // Low (  )
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   
   CheckNewBar();
//---     
   SoundNotification();
//---   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---     
   Print(GetDeinitReasonText(reason));
//---     ()
   Print("TERMINAL_MEMORY_USED: ",TerminalInfoInteger(TERMINAL_MEMORY_USED)," Mb");
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void OnTick()
  {
//---    , 
   if(!CheckNewBar())
      return;
//---    
   else
     {
      GetBarsData();        //   
      TradingBlock();       //    
      ModifyTrailingStop(); //   Trailing Stop
     }
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---  
   SoundNotification();
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void SoundNotification()
  {
//---  -   
   if(IsRealtime() && UseSound)
     {
      ulong        ticket      =0; //  
      int          total       =0; //  - 
      static ulong last_ticket =0; //     
      //---   
      if(!HistorySelect(0,TimeCurrent()+1000))
         return;
      //---      
      total=HistoryDealsTotal();
      //---       :    
      for(int i=total-1; i>=0; i--)
        {
         //---         
         if((ticket=HistoryDealGetTicket(i))>0)
           {
            //---   
            GetHistoryDealProperties(ticket,D_SYMBOL);
            //---       
            if(deal.symbol==_Symbol)
              {
               //---   
               GetHistoryDealProperties(ticket,D_ENTRY);
               //---    ,    
               if(deal.entry==DEAL_ENTRY_OUT || deal.entry==DEAL_ENTRY_INOUT)
                 {
                  //---       (  )  
                  //         
                  if(ticket==last_ticket || last_ticket==0)
                    {
                     //---    
                     last_ticket=ticket;
                     return;
                    }
                  //---   
                  GetHistoryDealProperties(ticket,D_PROFIT);
                  //---  
                  if(deal.profit>=0)
                    {
                     //---  
                     PlaySoundByID(SOUND_CLOSE_WITH_PROFIT);
                     //---   
                     last_ticket=ticket;
                     return;
                    }
                  //---  
                  if(deal.profit<0)
                    {
                     //---  
                     PlaySoundByID(SOUND_CLOSE_WITH_LOSS);
                     //---   
                     last_ticket=ticket;
                     return;
                    }
                 }
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void PlaySoundByID(ENUM_SOUNDS id)
  {
//---   -   
   if(IsRealtime() && UseSound)
     {
      //---     
      switch(id)
        {
         case SOUND_ERROR              : PlaySound(SoundError);            break;
         case SOUND_OPEN_POSITION      : PlaySound(SoundOpenPosition);     break;
         case SOUND_ADJUST_ORDER       : PlaySound(SoundAdjustOrder);      break;
         case SOUND_CLOSE_WITH_PROFIT  : PlaySound(SoundCloseWithProfit);  break;
         case SOUND_CLOSE_WITH_LOSS    : PlaySound(SoundCloseWithLoss);    break;
        }
     }
  }
//+------------------------------------------------------------------+
