//+------------------------------------------------------------------+
//|                                                   SoundPanel.mq5 |
//|            Copyright 2013, https://login.mql5.com/ru/users/tol64 |
//|                                  Site, http://tol64.blogspot.com |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2013, http://tol64.blogspot.com"
#property link        "http://tol64.blogspot.com"
#property description "email: hello.tol64@gmail.com"
#property version     "1.0"
//---  
#define ARRAY_SIZE 26
//---  
#resource "\\Files\\Sounds\\alert.wav"
#resource "\\Files\\Sounds\\AHOOGA.wav"
#resource "\\Files\\Sounds\\APPLAUSE.wav"
#resource "\\Files\\Sounds\\BONK.wav"
#resource "\\Files\\Sounds\\CARBRAKE.wav"
#resource "\\Files\\Sounds\\CASHREG.wav"
#resource "\\Files\\Sounds\\CLAP.wav"
#resource "\\Files\\Sounds\\CORKPOP.wav"
#resource "\\Files\\Sounds\\DOG.wav"
#resource "\\Files\\Sounds\\DRIVEBY.wav"
#resource "\\Files\\Sounds\\DRUMROLL.wav"
#resource "\\Files\\Sounds\\EXPLODE.wav"
#resource "\\Files\\Sounds\\FINALBEL.wav"
#resource "\\Files\\Sounds\\FROG.wav"
#resource "\\Files\\Sounds\\GLASS.wav"
#resource "\\Files\\Sounds\\GUNSHOT.wav"
#resource "\\Files\\Sounds\\LASER.wav"
#resource "\\Files\\Sounds\\LATNWHIS.wav"
#resource "\\Files\\Sounds\\PIG.wav"
#resource "\\Files\\Sounds\\RICOCHET.wav"
#resource "\\Files\\Sounds\\RINGIN.wav"
#resource "\\Files\\Sounds\\SIREN.wav"
#resource "\\Files\\Sounds\\TRAIN.wav"
#resource "\\Files\\Sounds\\UH_OH.wav"
#resource "\\Files\\Sounds\\VERYGOOD.wav"
#resource "\\Files\\Sounds\\WHOOSH.wav"
//---    
string sound_paths[ARRAY_SIZE]=
  {
   "::Files\\Sounds\\alert.wav",
   "::Files\\Sounds\\AHOOGA.wav",
   "::Files\\Sounds\\APPLAUSE.wav",
   "::Files\\Sounds\\BONK.wav",
   "::Files\\Sounds\\CARBRAKE.wav",
   "::Files\\Sounds\\CASHREG.wav",
   "::Files\\Sounds\\CLAP.wav",
   "::Files\\Sounds\\CORKPOP.wav",
   "::Files\\Sounds\\DOG.wav",
   "::Files\\Sounds\\DRIVEBY.wav",
   "::Files\\Sounds\\DRUMROLL.wav",
   "::Files\\Sounds\\EXPLODE.wav",
   "::Files\\Sounds\\FINALBEL.wav",
   "::Files\\Sounds\\FROG.wav",
   "::Files\\Sounds\\GLASS.wav",
   "::Files\\Sounds\\GUNSHOT.wav",
   "::Files\\Sounds\\LASER.wav",
   "::Files\\Sounds\\LATNWHIS.wav",
   "::Files\\Sounds\\PIG.wav",
   "::Files\\Sounds\\RICOCHET.wav",
   "::Files\\Sounds\\RINGIN.wav",
   "::Files\\Sounds\\SIREN.wav",
   "::Files\\Sounds\\TRAIN.wav",
   "::Files\\Sounds\\UH_OH.wav",
   "::Files\\Sounds\\VERYGOOD.wav",
   "::Files\\Sounds\\WHOOSH.wav"
  };
//---   
string sound_names[ARRAY_SIZE]=
  {
   "sound_button01","sound_button02",
   "sound_button03","sound_button04",
   "sound_button05","sound_button06",
   "sound_button07","sound_button08",
   "sound_button09","sound_button10",
   "sound_button11","sound_button12",
   "sound_button13","sound_button14",
   "sound_button15","sound_button16",
   "sound_button17","sound_button18",
   "sound_button19","sound_button20",
   "sound_button21","sound_button22",
   "sound_button23","sound_button24",
   "sound_button25","sound_button26"
  };
//---     
string sound_texts[ARRAY_SIZE]=
  {
   "ALERT","AHOOGA","APPLAUSE","BONK","CARBRAKE","CASHREG",
   "CLAP","CORKPOP","DOG","DRIVEBY","DRUMROLL","EXPLODE","FINALBEL",
   "FROG","GLASS","GUNSHOT","LASER","LATNWHIS","PIG",
   "RICOCHET","RINGIN","SIREN","TRAIN","UH_OH","VERYGOOD","WHOOSH"
  };
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//---   
   SetSoundPanel();
  }
//+------------------------------------------------------------------+
//| Deinitialization function of the expert                          |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---   
   DeleteSoundPanel();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
  }
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
void OnChartEvent(const int     id,     //    
                  const long&   lparam, //    long
                  const double& dparam, //    double
                  const string& sparam) //    string
  {
//---    "     "
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      //---      "sound_button"
      if(StringFind(sparam,"sound_button",0)>=0)
        {
         //---     
         //    5019 - ERR_FILE_NOT_EXIST -   
         if(!PlaySound(GetSoundPath(sparam)))
            Print("Error: ",GetLastError());
         //---    
         ChangeColorsOnSoundPanel();
        }
     }
  }
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
void SetSoundPanel()
  {
   int   column_count =0;       //  
   int   x_dist       =10;      //     
   int   y_dist       =15;      //     
   int   x_size       =100;     //  
   int   y_size       =20;      //  
   color button_color =clrNONE; //  
//---  
   for(int i=0; i<ARRAY_SIZE; i++)
     {
      //---   
      column_count++;
      //---    
      button_color=GetRandomColor();
      //---  
      CreateButton(0,0,sound_names[i],sound_texts[i],
                   ANCHOR_LEFT_UPPER,CORNER_LEFT_UPPER,"Arial",8,
                   clrWhite,button_color,button_color,x_size,y_size,x_dist,y_dist,1);
      //---        
      if(column_count==2)
        {
         x_dist=10;        //  X    
         y_dist+=20;       //  Y    
         column_count=0;   //  
        }
      else
      //---   X    
         x_dist+=x_size;
     }
//---  
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
void ChangeColorsOnSoundPanel()
  {
   color clr=clrNONE; //  
//---          
   for(int i=0; i<ARRAY_SIZE; i++)
     {
      //---   
      clr=GetRandomColor();
      //---   
      ObjectSetInteger(0,sound_names[i],OBJPROP_BGCOLOR,clr);
      //---   
      ObjectSetInteger(0,sound_names[i],OBJPROP_BORDER_COLOR,clr);
      //---   
      ObjectSetInteger(0,sound_names[i],OBJPROP_STATE,false);
      //---  
      ChartRedraw(0);
      //---  () 20 
      Sleep(20);
     }
  }
//+------------------------------------------------------------------+
//|   Button                                          |
//+------------------------------------------------------------------+
void CreateButton(long              chart_id,         // id 
                  int               sub_window,       //  
                  string            name,             //  
                  string            text,             //  
                  ENUM_ANCHOR_POINT anchor,           //  
                  ENUM_BASE_CORNER  corner,           //  
                  string            font_name,        // 
                  int               font_size,        //  
                  color             font_color,       //  
                  color             background_color, //  
                  color             border_color,     //  
                  int               x_size,           // 
                  int               y_size,           // 
                  int               x_distance,       //    X
                  int               y_distance,       //    Y
                  long              z_order)          // 
  {
//---  
   if(ObjectCreate(chart_id,name,OBJ_BUTTON,sub_window,0,0))
     {
      ObjectSetString(chart_id,name,OBJPROP_TEXT,text);                  //  
      ObjectSetString(chart_id,name,OBJPROP_FONT,font_name);             //  
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,font_color);          //   
      ObjectSetInteger(chart_id,name,OBJPROP_BGCOLOR,background_color);  //   
      ObjectSetInteger(chart_id,name,OBJPROP_BORDER_COLOR,border_color); //   
      ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,anchor);             //   
      ObjectSetInteger(chart_id,name,OBJPROP_CORNER,corner);             //   
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,font_size);        //   
      ObjectSetInteger(chart_id,name,OBJPROP_XSIZE,x_size);              //   X
      ObjectSetInteger(chart_id,name,OBJPROP_YSIZE,y_size);              //   Y
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,x_distance);      //   X
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,y_distance);      //   Y
      ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,false);          //   ,  FALSE
      ObjectSetInteger(chart_id,name,OBJPROP_STATE,false);               //   (/)
      ObjectSetInteger(chart_id,name,OBJPROP_ZORDER,z_order);            //  /
      ObjectSetString(chart_id,name,OBJPROP_TOOLTIP,"\n");               //   ,  "\n"
     }
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
string GetSoundPath(string object_name)
  {
//---        
   for(int i=0; i<ARRAY_SIZE; i++)
     {
      //---   ,     
      //        ,    ,    
      if(object_name==sound_names[i])
         return(sound_paths[i]);
     }
//---
   return("");
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void DeleteSoundPanel()
  {
//---      
   for(int i=0; i<ARRAY_SIZE; i++)
      DeleteObjectByName(sound_names[i]);
//---  
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
void DeleteObjectByName(string name)
  {
//---   
   if(ObjectFind(ChartID(),name)>=0)
     {
      //---     ,   
      if(!ObjectDelete(ChartID(),name))
         Print(" ("+IntegerToString(GetLastError())+")   !");
     }
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
color GetRandomColor()
  {
//---    
//   MathSrand(GetTickCount());
//---     0  25
   switch(MathRand()%26)
     {
      case 0  : return(clrOrange);           break;
      case 1  : return(clrGold);             break;
      case 2  : return(clrChocolate);        break;
      case 3  : return(clrChartreuse);       break;
      case 4  : return(clrLime);             break;
      case 5  : return(clrSpringGreen);      break;
      case 6  : return(clrMediumBlue);       break;
      case 7  : return(clrDeepSkyBlue);      break;
      case 8  : return(clrBlue);             break;
      case 9  : return(clrSeaGreen);         break;
      case 10 : return(clrRed);              break;
      case 11 : return(clrSlateGray);        break;
      case 12 : return(clrPeru);             break;
      case 13 : return(clrBlueViolet);       break;
      case 14 : return(clrIndianRed);        break;
      case 15 : return(clrMediumOrchid);     break;
      case 16 : return(clrCrimson);          break;
      case 17 : return(clrMediumAquamarine); break;
      case 18 : return(clrDarkGray);         break;
      case 19 : return(clrSandyBrown);       break;
      case 20 : return(clrMediumSlateBlue);  break;
      case 21 : return(clrTan);              break;
      case 22 : return(clrDarkSalmon);       break;
      case 23 : return(clrBurlyWood);        break;
      case 24 : return(clrHotPink);          break;
      case 25 : return(clrLightSteelBlue);   break;
      //---
      default : return(clrGold);
     }
//---
   return(clrGold);
  }
//+------------------------------------------------------------------+
